=== debian/changelog ===
gudhi (2.3.0+dfsg-2) unstable; urgency=medium

  * Disable parallel building on certain architectures to avoid buildds
    running out of memory.
  * New patch to properly propagate CXXFLAGS when building the Python
    modules.

 -- Gard Spreemann <gspreemann@gmail.com>  Fri, 05 Oct 2018 17:05:03 +0200

gudhi (2.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release:
    - Python interface for GIC.
  * Refresh patches:
    - Expand patch to disable new tests that rely on DFSG-deleted data.
  * Standards-version 4.2.1. No changes needed.

 -- Gard Spreemann <gspreemann@gmail.com>  Tue, 11 Sep 2018 16:10:44 +0200

gudhi (2.2.0+dfsg-3) unstable; urgency=medium

  * Fix build of bindings for multiple Python versions when building just
    binary-arch.
  * Test all supported Python (3) versions.

 -- Gard Spreemann <gspreemann@gmail.com>  Tue, 14 Aug 2018 13:45:43 +0200
